//-------------------------------------------------------------------------------------------------
// TheGameInterface.cpp (game)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#include "pch.h"
#include "TheGameInterface.h"
#include "TheGame.h"
using namespace std;


//-------------------------------------------------------------------------------------------------
// Static member initialization
//-------------------------------------------------------------------------------------------------
STATIC TheGameInterface TheGameInterface::_theGameInterface; // instantiated at application startup


//-------------------------------------------------------------------------------------------------
// Destructor()
//-------------------------------------------------------------------------------------------------
TheGameInterface::~TheGameInterface()
{
}


//-------------------------------------------------------------------------------------------------
// Constructor
//-------------------------------------------------------------------------------------------------
TheGameInterface::TheGameInterface()
{
	// Do nothing (this is a lightweight interface class)
}


//-------------------------------------------------------------------------------------------------
// PreInit
//-------------------------------------------------------------------------------------------------
void TheGameInterface::PreInit()
{
	g_game = new TheGame();
	g_game->PreInit();
}


//-------------------------------------------------------------------------------------------------
// PostInit
//-------------------------------------------------------------------------------------------------
void TheGameInterface::PostInit()
{
	g_game->PostInit();
}


//-------------------------------------------------------------------------------------------------
// Shutdown
//-------------------------------------------------------------------------------------------------
void TheGameInterface::Shutdown()
{
}


//-------------------------------------------------------------------------------------------------
// RunFrame
//-------------------------------------------------------------------------------------------------
void TheGameInterface::RunFrame()
{
	g_game->RunFrame();
}


//-------------------------------------------------------------------------------------------------
// ProcessCommandLine
//-------------------------------------------------------------------------------------------------
VIRTUAL void TheGameInterface::ProcessCommandLine( string cmdLine )
{
}


//-------------------------------------------------------------------------------------------------
// ProcessInputEvent
//-------------------------------------------------------------------------------------------------
VIRTUAL const bool TheGameInterface::ProcessInputEvent( const TheInputSystem::inputEventType_e eventType, const byte_t key )
{
	if( eventType == TheInputSystem::INPUT_EVENT_KEYDOWN )
	{
		g_game->OnKeyDown( key );
	}
	else if( eventType == TheInputSystem::INPUT_EVENT_KEYUP )
	{
		g_game->OnKeyUp( key );
	}

	return false;
}
